module: dylan-user

define module iop-protocol
  use common-dylan;
  use corba-protocol;
  export
    IOP/<ProfileId>,
    IOP/$TAG-INTERNET-IOP,
    IOP/$TAG-MULTIPLE-COMPONENTS,
    IOP/<TaggedProfile>,
    IOP/TaggedProfile/tag,
    IOP/TaggedProfile/tag-setter,
    IOP/TaggedProfile/profile-data,
    IOP/TaggedProfile/profile-data-setter,
    IOP/<IOR>,
    IOP/IOR/type-id,
    IOP/IOR/type-id-setter,
    IOP/IOR/profiles,
    IOP/IOR/profiles-setter,
    IOP/<ComponentId>,
    IOP/<TaggedComponent>,
    IOP/TaggedComponent/tag,
    IOP/TaggedComponent/tag-setter,
    IOP/TaggedComponent/component-data,
    IOP/TaggedComponent/component-data-setter,
    IOP/<MultipleComponentProfile>,
    IOP/$TAG-ORB-TYPE,
    IOP/$TAG-CODE-SETS,
    IOP/$TAG-SEC-NAME,
    IOP/$TAG-ASSOCIATION-OPTION,
    IOP/<ServiceID>,
    IOP/<ServiceContext>,
    IOP/ServiceContext/context-id,
    IOP/ServiceContext/context-id-setter,
    IOP/ServiceContext/context-data,
    IOP/ServiceContext/context-data-setter,
    IOP/<ServiceContextList>,
    IOP/$TransactionService,
    IOP/$CodeSets,
    CONV-FRAME/<CodeSetId>,
    CONV-FRAME/<CodeSetComponent>,
    CONV-FRAME/CodeSetComponent/native-code-set,
    CONV-FRAME/CodeSetComponent/native-code-set-setter,
    CONV-FRAME/CodeSetComponent/conversion-code-sets,
    CONV-FRAME/CodeSetComponent/conversion-code-sets-setter,
    CONV-FRAME/<CodeSetComponentInfo>,
    CONV-FRAME/CodeSetComponentInfo/ForCharData,
    CONV-FRAME/CodeSetComponentInfo/ForCharData-setter,
    CONV-FRAME/CodeSetComponentInfo/ForWcharData,
    CONV-FRAME/CodeSetComponentInfo/ForWcharData-setter,
    CONV-FRAME/<CodeSetContext>,
    CONV-FRAME/CodeSetContext/char-data,
    CONV-FRAME/CodeSetContext/char-data-setter,
    CONV-FRAME/CodeSetContext/wchar-data,
    CONV-FRAME/CodeSetContext/wchar-data-setter,
    GIOP/<Principal>,
    GIOP/<Version>,
    GIOP/Version/major,
    GIOP/Version/major-setter,
    GIOP/Version/minor,
    GIOP/Version/minor-setter,
    GIOP/<MsgType-1-0>,
    GIOP/MsgType-1-0/successor,
    GIOP/MsgType-1-0/predecessor,
    GIOP/MsgType-1-0/>,
    GIOP/MsgType-1-0/<,
    GIOP/<MessageHeader-1-0>,
    GIOP/MessageHeader-1-0/magic,
    GIOP/MessageHeader-1-0/magic-setter,
    GIOP/MessageHeader-1-0/GIOP-version,
    GIOP/MessageHeader-1-0/GIOP-version-setter,
    GIOP/MessageHeader-1-0/byte-order,
    GIOP/MessageHeader-1-0/byte-order-setter,
    GIOP/MessageHeader-1-0/message-type,
    GIOP/MessageHeader-1-0/message-type-setter,
    GIOP/MessageHeader-1-0/message-size,
    GIOP/MessageHeader-1-0/message-size-setter,
    GIOP/<RequestHeader-1-0>,
    GIOP/RequestHeader-1-0/service-context,
    GIOP/RequestHeader-1-0/service-context-setter,
    GIOP/RequestHeader-1-0/request-id,
    GIOP/RequestHeader-1-0/request-id-setter,
    GIOP/RequestHeader-1-0/response-expected,
    GIOP/RequestHeader-1-0/response-expected-setter,
    GIOP/RequestHeader-1-0/object-key,
    GIOP/RequestHeader-1-0/object-key-setter,
    GIOP/RequestHeader-1-0/operation,
    GIOP/RequestHeader-1-0/operation-setter,
    GIOP/RequestHeader-1-0/requesting-principal,
    GIOP/RequestHeader-1-0/requesting-principal-setter,
    GIOP/<RequestHeader-1-1>,
    GIOP/RequestHeader-1-1/service-context,
    GIOP/RequestHeader-1-1/service-context-setter,
    GIOP/RequestHeader-1-1/request-id,
    GIOP/RequestHeader-1-1/request-id-setter,
    GIOP/RequestHeader-1-1/response-expected,
    GIOP/RequestHeader-1-1/response-expected-setter,
    GIOP/RequestHeader-1-1/reserved,
    GIOP/RequestHeader-1-1/reserved-setter,
    GIOP/RequestHeader-1-1/object-key,
    GIOP/RequestHeader-1-1/object-key-setter,
    GIOP/RequestHeader-1-1/operation,
    GIOP/RequestHeader-1-1/operation-setter,
    GIOP/RequestHeader-1-1/requesting-principal,
    GIOP/RequestHeader-1-1/requesting-principal-setter,
    GIOP/<ReplyStatusType>,
    GIOP/ReplyStatusType/successor,
    GIOP/ReplyStatusType/predecessor,
    GIOP/ReplyStatusType/>,
    GIOP/ReplyStatusType/<,
    GIOP/<ReplyHeader>,
    GIOP/ReplyHeader/service-context,
    GIOP/ReplyHeader/service-context-setter,
    GIOP/ReplyHeader/request-id,
    GIOP/ReplyHeader/request-id-setter,
    GIOP/ReplyHeader/reply-status,
    GIOP/ReplyHeader/reply-status-setter,
    GIOP/<CancelRequestHeader>,
    GIOP/CancelRequestHeader/request-id,
    GIOP/CancelRequestHeader/request-id-setter,
    GIOP/<LocateRequestHeader>,
    GIOP/LocateRequestHeader/request-id,
    GIOP/LocateRequestHeader/request-id-setter,
    GIOP/LocateRequestHeader/object-key,
    GIOP/LocateRequestHeader/object-key-setter,
    GIOP/<LocateStatusType>,
    GIOP/LocateStatusType/successor,
    GIOP/LocateStatusType/predecessor,
    GIOP/LocateStatusType/>,
    GIOP/LocateStatusType/<,
    GIOP/<LocateReplyHeader>,
    GIOP/LocateReplyHeader/request-id,
    GIOP/LocateReplyHeader/request-id-setter,
    GIOP/LocateReplyHeader/locate-status,
    GIOP/LocateReplyHeader/locate-status-setter,
    IIOP/<Version>,
    IIOP/Version/major,
    IIOP/Version/major-setter,
    IIOP/Version/minor,
    IIOP/Version/minor-setter,
    IIOP/<ProfileBody-1-0>,
    IIOP/ProfileBody-1-0/iiop-version,
    IIOP/ProfileBody-1-0/iiop-version-setter,
    IIOP/ProfileBody-1-0/host,
    IIOP/ProfileBody-1-0/host-setter,
    IIOP/ProfileBody-1-0/port,
    IIOP/ProfileBody-1-0/port-setter,
    IIOP/ProfileBody-1-0/object-key,
    IIOP/ProfileBody-1-0/object-key-setter,
    IIOP/<ProfileBody-1-1>,
    IIOP/ProfileBody-1-1/iiop-version,
    IIOP/ProfileBody-1-1/iiop-version-setter,
    IIOP/ProfileBody-1-1/host,
    IIOP/ProfileBody-1-1/host-setter,
    IIOP/ProfileBody-1-1/port,
    IIOP/ProfileBody-1-1/port-setter,
    IIOP/ProfileBody-1-1/object-key,
    IIOP/ProfileBody-1-1/object-key-setter,
    IIOP/ProfileBody-1-1/components,
    IIOP/ProfileBody-1-1/components-setter;
end;

