module: iop-protocol

define constant IOP/<ProfileId> = CORBA/<unsigned-long>;

define constant IOP/$TAG-INTERNET-IOP :: IOP/<ProfileId> = 0;

define constant IOP/$TAG-MULTIPLE-COMPONENTS :: IOP/<ProfileId> = 1;

define sealed class IOP/<TaggedProfile> (CORBA/<struct>)
  slot IOP/TaggedProfile/tag :: IOP/<ProfileId>, required-init-keyword: tag:;
  slot IOP/TaggedProfile/profile-data :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: profile-data:;
end class;
define sealed domain make (singleton(IOP/<TaggedProfile>));
define sealed domain initialize (IOP/<TaggedProfile>);

define constant IOP/$TaggedProfile-typecode = make(<struct-typecode>, type: IOP/<TaggedProfile>, name: "TaggedProfile", repository-id: "IDL:omg.org/IOP/TaggedProfile:1.0", members: vector(make(<typecode-member>, name: "tag", type: IOP/<ProfileId>, getter: IOP/TaggedProfile/tag, setter: IOP/TaggedProfile/tag-setter, init-keyword: tag:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "profile_data", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: IOP/TaggedProfile/profile-data, setter: IOP/TaggedProfile/profile-data-setter, init-keyword: profile-data:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>)))));

define method class-typecode (class == IOP/<TaggedProfile>)
 => (typecode :: <struct-typecode>)
  IOP/$TaggedProfile-typecode;
end method;

define method object-typecode (object :: IOP/<TaggedProfile>)
 => (typecode :: <struct-typecode>)
  IOP/$TaggedProfile-typecode;
end method;

define sealed class IOP/<IOR> (CORBA/<struct>)
  slot IOP/IOR/type-id :: CORBA/<string>, required-init-keyword: type-id:;
  slot IOP/IOR/profiles :: limited(CORBA/<sequence>, of: IOP/<TaggedProfile>), required-init-keyword: profiles:;
end class;
define sealed domain make (singleton(IOP/<IOR>));
define sealed domain initialize (IOP/<IOR>);

define constant IOP/$IOR-typecode = make(<struct-typecode>, type: IOP/<IOR>, name: "IOR", repository-id: "IDL:omg.org/IOP/IOR:1.0", members: vector(make(<typecode-member>, name: "type_id", type: CORBA/<string>, getter: IOP/IOR/type-id, setter: IOP/IOR/type-id-setter, init-keyword: type-id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "profiles", type: limited(CORBA/<sequence>, of: IOP/<TaggedProfile>), getter: IOP/IOR/profiles, setter: IOP/IOR/profiles-setter, init-keyword: profiles:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: IOP/<TaggedProfile>), type: limited(CORBA/<sequence>, of: IOP/<TaggedProfile>), max-length: 0, element-typecode: class-typecode(IOP/<TaggedProfile>)))));

define method class-typecode (class == IOP/<IOR>)
 => (typecode :: <struct-typecode>)
  IOP/$IOR-typecode;
end method;

define method object-typecode (object :: IOP/<IOR>)
 => (typecode :: <struct-typecode>)
  IOP/$IOR-typecode;
end method;

define constant IOP/<ComponentId> = CORBA/<unsigned-long>;

define sealed class IOP/<TaggedComponent> (CORBA/<struct>)
  slot IOP/TaggedComponent/tag :: IOP/<ComponentId>, required-init-keyword: tag:;
  slot IOP/TaggedComponent/component-data :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: component-data:;
end class;
define sealed domain make (singleton(IOP/<TaggedComponent>));
define sealed domain initialize (IOP/<TaggedComponent>);

define constant IOP/$TaggedComponent-typecode = make(<struct-typecode>, type: IOP/<TaggedComponent>, name: "TaggedComponent", repository-id: "IDL:omg.org/IOP/TaggedComponent:1.0", members: vector(make(<typecode-member>, name: "tag", type: IOP/<ComponentId>, getter: IOP/TaggedComponent/tag, setter: IOP/TaggedComponent/tag-setter, init-keyword: tag:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "component_data", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: IOP/TaggedComponent/component-data, setter: IOP/TaggedComponent/component-data-setter, init-keyword: component-data:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>)))));

define method class-typecode (class == IOP/<TaggedComponent>)
 => (typecode :: <struct-typecode>)
  IOP/$TaggedComponent-typecode;
end method;

define method object-typecode (object :: IOP/<TaggedComponent>)
 => (typecode :: <struct-typecode>)
  IOP/$TaggedComponent-typecode;
end method;

define constant IOP/<MultipleComponentProfile> = limited(CORBA/<sequence>, of: IOP/<TaggedComponent>);

define constant IOP/$TAG-ORB-TYPE :: IOP/<ComponentId> = 0;

define constant IOP/$TAG-CODE-SETS :: IOP/<ComponentId> = 1;

define constant IOP/$TAG-SEC-NAME :: IOP/<ComponentId> = 2;

define constant IOP/$TAG-ASSOCIATION-OPTION :: IOP/<ComponentId> = 3;

define constant IOP/<ServiceID> = CORBA/<unsigned-long>;

define sealed class IOP/<ServiceContext> (CORBA/<struct>)
  slot IOP/ServiceContext/context-id :: IOP/<ServiceID>, required-init-keyword: context-id:;
  slot IOP/ServiceContext/context-data :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: context-data:;
end class;
define sealed domain make (singleton(IOP/<ServiceContext>));
define sealed domain initialize (IOP/<ServiceContext>);

define constant IOP/$ServiceContext-typecode = make(<struct-typecode>, type: IOP/<ServiceContext>, name: "ServiceContext", repository-id: "IDL:omg.org/IOP/ServiceContext:1.0", members: vector(make(<typecode-member>, name: "context_id", type: IOP/<ServiceID>, getter: IOP/ServiceContext/context-id, setter: IOP/ServiceContext/context-id-setter, init-keyword: context-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "context_data", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: IOP/ServiceContext/context-data, setter: IOP/ServiceContext/context-data-setter, init-keyword: context-data:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>)))));

define method class-typecode (class == IOP/<ServiceContext>)
 => (typecode :: <struct-typecode>)
  IOP/$ServiceContext-typecode;
end method;

define method object-typecode (object :: IOP/<ServiceContext>)
 => (typecode :: <struct-typecode>)
  IOP/$ServiceContext-typecode;
end method;

define constant IOP/<ServiceContextList> = limited(CORBA/<sequence>, of: IOP/<ServiceContext>);

define constant IOP/$TransactionService :: IOP/<ServiceID> = 0;

define constant IOP/$CodeSets :: IOP/<ServiceID> = 1;

define constant CONV-FRAME/<CodeSetId> = CORBA/<unsigned-long>;

define sealed class CONV-FRAME/<CodeSetComponent> (CORBA/<struct>)
  slot CONV-FRAME/CodeSetComponent/native-code-set :: CONV-FRAME/<CodeSetId>, required-init-keyword: native-code-set:;
  slot CONV-FRAME/CodeSetComponent/conversion-code-sets :: limited(CORBA/<sequence>, of: CONV-FRAME/<CodeSetId>), required-init-keyword: conversion-code-sets:;
end class;
define sealed domain make (singleton(CONV-FRAME/<CodeSetComponent>));
define sealed domain initialize (CONV-FRAME/<CodeSetComponent>);

define constant CONV-FRAME/$CodeSetComponent-typecode = make(<struct-typecode>, type: CONV-FRAME/<CodeSetComponent>, name: "CodeSetComponent", repository-id: "IDL:omg.org/CONV_FRAME/CodeSetComponent:1.0", members: vector(make(<typecode-member>, name: "native_code_set", type: CONV-FRAME/<CodeSetId>, getter: CONV-FRAME/CodeSetComponent/native-code-set, setter: CONV-FRAME/CodeSetComponent/native-code-set-setter, init-keyword: native-code-set:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "conversion_code_sets", type: limited(CORBA/<sequence>, of: CONV-FRAME/<CodeSetId>), getter: CONV-FRAME/CodeSetComponent/conversion-code-sets, setter: CONV-FRAME/CodeSetComponent/conversion-code-sets-setter, init-keyword: conversion-code-sets:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CONV-FRAME/<CodeSetId>), type: limited(CORBA/<sequence>, of: CONV-FRAME/<CodeSetId>), max-length: 0, element-typecode: make(<unsigned-long-typecode>)))));

define method class-typecode (class == CONV-FRAME/<CodeSetComponent>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetComponent-typecode;
end method;

define method object-typecode (object :: CONV-FRAME/<CodeSetComponent>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetComponent-typecode;
end method;

define sealed class CONV-FRAME/<CodeSetComponentInfo> (CORBA/<struct>)
  slot CONV-FRAME/CodeSetComponentInfo/ForCharData :: CONV-FRAME/<CodeSetComponent>, required-init-keyword: ForCharData:;
  slot CONV-FRAME/CodeSetComponentInfo/ForWcharData :: CONV-FRAME/<CodeSetComponent>, required-init-keyword: ForWcharData:;
end class;
define sealed domain make (singleton(CONV-FRAME/<CodeSetComponentInfo>));
define sealed domain initialize (CONV-FRAME/<CodeSetComponentInfo>);

define constant CONV-FRAME/$CodeSetComponentInfo-typecode = make(<struct-typecode>, type: CONV-FRAME/<CodeSetComponentInfo>, name: "CodeSetComponentInfo", repository-id: "IDL:omg.org/CONV_FRAME/CodeSetComponentInfo:1.0", members: vector(make(<typecode-member>, name: "ForCharData", type: CONV-FRAME/<CodeSetComponent>, getter: CONV-FRAME/CodeSetComponentInfo/ForCharData, setter: CONV-FRAME/CodeSetComponentInfo/ForCharData-setter, init-keyword: ForCharData:, typecode: class-typecode(CONV-FRAME/<CodeSetComponent>)), make(<typecode-member>, name: "ForWcharData", type: CONV-FRAME/<CodeSetComponent>, getter: CONV-FRAME/CodeSetComponentInfo/ForWcharData, setter: CONV-FRAME/CodeSetComponentInfo/ForWcharData-setter, init-keyword: ForWcharData:, typecode: class-typecode(CONV-FRAME/<CodeSetComponent>))));

define method class-typecode (class == CONV-FRAME/<CodeSetComponentInfo>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetComponentInfo-typecode;
end method;

define method object-typecode (object :: CONV-FRAME/<CodeSetComponentInfo>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetComponentInfo-typecode;
end method;

define sealed class CONV-FRAME/<CodeSetContext> (CORBA/<struct>)
  slot CONV-FRAME/CodeSetContext/char-data :: CONV-FRAME/<CodeSetId>, required-init-keyword: char-data:;
  slot CONV-FRAME/CodeSetContext/wchar-data :: CONV-FRAME/<CodeSetId>, required-init-keyword: wchar-data:;
end class;
define sealed domain make (singleton(CONV-FRAME/<CodeSetContext>));
define sealed domain initialize (CONV-FRAME/<CodeSetContext>);

define constant CONV-FRAME/$CodeSetContext-typecode = make(<struct-typecode>, type: CONV-FRAME/<CodeSetContext>, name: "CodeSetContext", repository-id: "IDL:omg.org/CONV_FRAME/CodeSetContext:1.0", members: vector(make(<typecode-member>, name: "char_data", type: CONV-FRAME/<CodeSetId>, getter: CONV-FRAME/CodeSetContext/char-data, setter: CONV-FRAME/CodeSetContext/char-data-setter, init-keyword: char-data:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "wchar_data", type: CONV-FRAME/<CodeSetId>, getter: CONV-FRAME/CodeSetContext/wchar-data, setter: CONV-FRAME/CodeSetContext/wchar-data-setter, init-keyword: wchar-data:, typecode: make(<unsigned-long-typecode>))));

define method class-typecode (class == CONV-FRAME/<CodeSetContext>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetContext-typecode;
end method;

define method object-typecode (object :: CONV-FRAME/<CodeSetContext>)
 => (typecode :: <struct-typecode>)
  CONV-FRAME/$CodeSetContext-typecode;
end method;

define constant GIOP/<Principal> = CORBA/<string>;

define sealed class GIOP/<Version> (CORBA/<struct>)
  slot GIOP/Version/major :: CORBA/<octet>, required-init-keyword: major:;
  slot GIOP/Version/minor :: CORBA/<octet>, required-init-keyword: minor:;
end class;
define sealed domain make (singleton(GIOP/<Version>));
define sealed domain initialize (GIOP/<Version>);

define constant GIOP/$Version-typecode = make(<struct-typecode>, type: GIOP/<Version>, name: "Version", repository-id: "IDL:omg.org/GIOP/Version:1.0", members: vector(make(<typecode-member>, name: "major", type: CORBA/<octet>, getter: GIOP/Version/major, setter: GIOP/Version/major-setter, init-keyword: major:, typecode: make(<octet-typecode>)), make(<typecode-member>, name: "minor", type: CORBA/<octet>, getter: GIOP/Version/minor, setter: GIOP/Version/minor-setter, init-keyword: minor:, typecode: make(<octet-typecode>))));

define method class-typecode (class == GIOP/<Version>)
 => (typecode :: <struct-typecode>)
  GIOP/$Version-typecode;
end method;

define method object-typecode (object :: GIOP/<Version>)
 => (typecode :: <struct-typecode>)
  GIOP/$Version-typecode;
end method;

define constant GIOP/<MsgType-1-0> = one-of(#"Request", #"Reply", #"CancelRequest", #"LocateRequest", #"LocateReply", #"CloseConnection", #"MessageError");

define generic GIOP/MsgType-1-0/successor (symbol :: GIOP/<MsgType-1-0>)
 => (succ :: GIOP/<MsgType-1-0>);

define generic GIOP/MsgType-1-0/predecessor (symbol :: GIOP/<MsgType-1-0>)
 => (pred :: GIOP/<MsgType-1-0>);

define generic GIOP/MsgType-1-0/< (lesser :: GIOP/<MsgType-1-0>, greater :: GIOP/<MsgType-1-0>)
 => (lesser? :: <boolean>);

define generic GIOP/MsgType-1-0/> (greater :: GIOP/<MsgType-1-0>, lesser :: GIOP/<MsgType-1-0>)
 => (greater? :: <boolean>);

define constant GIOP/$MsgType-1-0-typecode = make(<enum-typecode>, type: GIOP/<MsgType-1-0>, name: "MsgType_1_0", repository-id: "IDL:omg.org/GIOP/MsgType_1_0:1.0", members: vector(#"Request", #"Reply", #"CancelRequest", #"LocateRequest", #"LocateReply", #"CloseConnection", #"MessageError"));

define method class-typecode (class == GIOP/<MsgType-1-0>)
 => (typecode :: <enum-typecode>)
  GIOP/$MsgType-1-0-typecode;
end method;

define sideways method object-typecode (object :: GIOP/<MsgType-1-0>)
 => (typecode :: <enum-typecode>)
  GIOP/$MsgType-1-0-typecode;
end method;

define inline-only function GIOP/MsgType-1-0/as-symbol (integer :: <integer>)
 => (symbol :: GIOP/<MsgType-1-0>)
  let typecode = class-typecode(GIOP/<MsgType-1-0>);
  typecode-members(typecode)[integer];
end function;

define inline-only function GIOP/MsgType-1-0/as-integer (symbol :: GIOP/<MsgType-1-0>)
 => (integer :: <integer>)
  let typecode = class-typecode(GIOP/<MsgType-1-0>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method GIOP/MsgType-1-0/successor (symbol :: GIOP/<MsgType-1-0>)
 => (succ :: GIOP/<MsgType-1-0>)
  let i = GIOP/MsgType-1-0/as-integer(symbol);
  GIOP/MsgType-1-0/as-symbol(modulo(i + 1, 7));
end method;

define method GIOP/MsgType-1-0/predecessor (symbol :: GIOP/<MsgType-1-0>)
 => (pred :: GIOP/<MsgType-1-0>)
  let i = GIOP/MsgType-1-0/as-integer(symbol);
  GIOP/MsgType-1-0/as-symbol(modulo(7 + i - 1, 7));
end method;

define method GIOP/MsgType-1-0/< (lesser :: GIOP/<MsgType-1-0>, greater :: GIOP/<MsgType-1-0>)
 => (lesser? :: <boolean>)
  GIOP/MsgType-1-0/as-integer(lesser) < GIOP/MsgType-1-0/as-integer(greater);
end method;

define method GIOP/MsgType-1-0/> (greater :: GIOP/<MsgType-1-0>, lesser :: GIOP/<MsgType-1-0>)
 => (greater? :: <boolean>)
  GIOP/MsgType-1-0/as-integer(greater) > GIOP/MsgType-1-0/as-integer(lesser);
end method;

define sealed class GIOP/<MessageHeader-1-0> (CORBA/<struct>)
  slot GIOP/MessageHeader-1-0/magic :: limited(CORBA/<array>, of: CORBA/<char>, dimensions: #[4]), required-init-keyword: magic:;
  slot GIOP/MessageHeader-1-0/GIOP-version :: GIOP/<Version>, required-init-keyword: GIOP-version:;
  slot GIOP/MessageHeader-1-0/byte-order :: CORBA/<boolean>, required-init-keyword: byte-order:;
  slot GIOP/MessageHeader-1-0/message-type :: CORBA/<octet>, required-init-keyword: message-type:;
  slot GIOP/MessageHeader-1-0/message-size :: CORBA/<unsigned-long>, required-init-keyword: message-size:;
end class;
define sealed domain make (singleton(GIOP/<MessageHeader-1-0>));
define sealed domain initialize (GIOP/<MessageHeader-1-0>);

define constant GIOP/$MessageHeader-1-0-typecode = make(<struct-typecode>, type: GIOP/<MessageHeader-1-0>, name: "MessageHeader_1_0", repository-id: "IDL:omg.org/GIOP/MessageHeader_1_0:1.0", members: vector(make(<typecode-member>, name: "magic", type: limited(CORBA/<array>, of: CORBA/<char>, dimensions: #[4]), getter: GIOP/MessageHeader-1-0/magic, setter: GIOP/MessageHeader-1-0/magic-setter, init-keyword: magic:, typecode: make(<array-typecode>, type: limited(CORBA/<array>, of: CORBA/<char>, dimensions: #[4]), type: limited(CORBA/<array>, of: CORBA/<char>, dimensions: #[4]), length: 4, element-typecode: make(<char-typecode>))), make(<typecode-member>, name: "GIOP_version", type: GIOP/<Version>, getter: GIOP/MessageHeader-1-0/GIOP-version, setter: GIOP/MessageHeader-1-0/GIOP-version-setter, init-keyword: GIOP-version:, typecode: class-typecode(GIOP/<Version>)), make(<typecode-member>, name: "byte_order", type: CORBA/<boolean>, getter: GIOP/MessageHeader-1-0/byte-order, setter: GIOP/MessageHeader-1-0/byte-order-setter, init-keyword: byte-order:, typecode: make(<boolean-typecode>)), make(<typecode-member>, name: "message_type", type: CORBA/<octet>, getter: GIOP/MessageHeader-1-0/message-type, setter: GIOP/MessageHeader-1-0/message-type-setter, init-keyword: message-type:, typecode: make(<octet-typecode>)), make(<typecode-member>, name: "message_size", type: CORBA/<unsigned-long>, getter: GIOP/MessageHeader-1-0/message-size, setter: GIOP/MessageHeader-1-0/message-size-setter, init-keyword: message-size:, typecode: make(<unsigned-long-typecode>))));

define method class-typecode (class == GIOP/<MessageHeader-1-0>)
 => (typecode :: <struct-typecode>)
  GIOP/$MessageHeader-1-0-typecode;
end method;

define method object-typecode (object :: GIOP/<MessageHeader-1-0>)
 => (typecode :: <struct-typecode>)
  GIOP/$MessageHeader-1-0-typecode;
end method;

define sealed class GIOP/<RequestHeader-1-0> (CORBA/<struct>)
  slot GIOP/RequestHeader-1-0/service-context :: IOP/<ServiceContextList>, required-init-keyword: service-context:;
  slot GIOP/RequestHeader-1-0/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
  slot GIOP/RequestHeader-1-0/response-expected :: CORBA/<boolean>, required-init-keyword: response-expected:;
  slot GIOP/RequestHeader-1-0/object-key :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: object-key:;
  slot GIOP/RequestHeader-1-0/operation :: CORBA/<string>, required-init-keyword: operation:;
  slot GIOP/RequestHeader-1-0/requesting-principal :: GIOP/<Principal>, required-init-keyword: requesting-principal:;
end class;
define sealed domain make (singleton(GIOP/<RequestHeader-1-0>));
define sealed domain initialize (GIOP/<RequestHeader-1-0>);

define constant GIOP/$RequestHeader-1-0-typecode = make(<struct-typecode>, type: GIOP/<RequestHeader-1-0>, name: "RequestHeader_1_0", repository-id: "IDL:omg.org/GIOP/RequestHeader_1_0:1.0", members: vector(make(<typecode-member>, name: "service_context", type: IOP/<ServiceContextList>, getter: GIOP/RequestHeader-1-0/service-context, setter: GIOP/RequestHeader-1-0/service-context-setter, init-keyword: service-context:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), max-length: 0, element-typecode: class-typecode(IOP/<ServiceContext>))), make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/RequestHeader-1-0/request-id, setter: GIOP/RequestHeader-1-0/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "response_expected", type: CORBA/<boolean>, getter: GIOP/RequestHeader-1-0/response-expected, setter: GIOP/RequestHeader-1-0/response-expected-setter, init-keyword: response-expected:, typecode: make(<boolean-typecode>)), make(<typecode-member>, name: "object_key", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: GIOP/RequestHeader-1-0/object-key, setter: GIOP/RequestHeader-1-0/object-key-setter, init-keyword: object-key:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>))), make(<typecode-member>, name: "operation", type: CORBA/<string>, getter: GIOP/RequestHeader-1-0/operation, setter: GIOP/RequestHeader-1-0/operation-setter, init-keyword: operation:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "requesting_principal", type: GIOP/<Principal>, getter: GIOP/RequestHeader-1-0/requesting-principal, setter: GIOP/RequestHeader-1-0/requesting-principal-setter, init-keyword: requesting-principal:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))));

define method class-typecode (class == GIOP/<RequestHeader-1-0>)
 => (typecode :: <struct-typecode>)
  GIOP/$RequestHeader-1-0-typecode;
end method;

define method object-typecode (object :: GIOP/<RequestHeader-1-0>)
 => (typecode :: <struct-typecode>)
  GIOP/$RequestHeader-1-0-typecode;
end method;

define sealed class GIOP/<RequestHeader-1-1> (CORBA/<struct>)
  slot GIOP/RequestHeader-1-1/service-context :: IOP/<ServiceContextList>, required-init-keyword: service-context:;
  slot GIOP/RequestHeader-1-1/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
  slot GIOP/RequestHeader-1-1/response-expected :: CORBA/<boolean>, required-init-keyword: response-expected:;
  slot GIOP/RequestHeader-1-1/reserved :: limited(CORBA/<array>, of: CORBA/<octet>, dimensions: #[3]), required-init-keyword: reserved:;
  slot GIOP/RequestHeader-1-1/object-key :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: object-key:;
  slot GIOP/RequestHeader-1-1/operation :: CORBA/<string>, required-init-keyword: operation:;
  slot GIOP/RequestHeader-1-1/requesting-principal :: GIOP/<Principal>, required-init-keyword: requesting-principal:;
end class;
define sealed domain make (singleton(GIOP/<RequestHeader-1-1>));
define sealed domain initialize (GIOP/<RequestHeader-1-1>);

define constant GIOP/$RequestHeader-1-1-typecode = make(<struct-typecode>, type: GIOP/<RequestHeader-1-1>, name: "RequestHeader_1_1", repository-id: "IDL:omg.org/GIOP/RequestHeader_1_1:1.0", members: vector(make(<typecode-member>, name: "service_context", type: IOP/<ServiceContextList>, getter: GIOP/RequestHeader-1-1/service-context, setter: GIOP/RequestHeader-1-1/service-context-setter, init-keyword: service-context:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), max-length: 0, element-typecode: class-typecode(IOP/<ServiceContext>))), make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/RequestHeader-1-1/request-id, setter: GIOP/RequestHeader-1-1/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "response_expected", type: CORBA/<boolean>, getter: GIOP/RequestHeader-1-1/response-expected, setter: GIOP/RequestHeader-1-1/response-expected-setter, init-keyword: response-expected:, typecode: make(<boolean-typecode>)), make(<typecode-member>, name: "reserved", type: limited(CORBA/<array>, of: CORBA/<octet>, dimensions: #[3]), getter: GIOP/RequestHeader-1-1/reserved, setter: GIOP/RequestHeader-1-1/reserved-setter, init-keyword: reserved:, typecode: make(<array-typecode>, type: limited(CORBA/<array>, of: CORBA/<octet>, dimensions: #[3]), type: limited(CORBA/<array>, of: CORBA/<octet>, dimensions: #[3]), length: 3, element-typecode: make(<octet-typecode>))), make(<typecode-member>, name: "object_key", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: GIOP/RequestHeader-1-1/object-key, setter: GIOP/RequestHeader-1-1/object-key-setter, init-keyword: object-key:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>))), make(<typecode-member>, name: "operation", type: CORBA/<string>, getter: GIOP/RequestHeader-1-1/operation, setter: GIOP/RequestHeader-1-1/operation-setter, init-keyword: operation:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "requesting_principal", type: GIOP/<Principal>, getter: GIOP/RequestHeader-1-1/requesting-principal, setter: GIOP/RequestHeader-1-1/requesting-principal-setter, init-keyword: requesting-principal:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))));

define method class-typecode (class == GIOP/<RequestHeader-1-1>)
 => (typecode :: <struct-typecode>)
  GIOP/$RequestHeader-1-1-typecode;
end method;

define method object-typecode (object :: GIOP/<RequestHeader-1-1>)
 => (typecode :: <struct-typecode>)
  GIOP/$RequestHeader-1-1-typecode;
end method;

define constant GIOP/<ReplyStatusType> = one-of(#"NO-EXCEPTION", #"USER-EXCEPTION", #"SYSTEM-EXCEPTION", #"LOCATION-FORWARD");

define generic GIOP/ReplyStatusType/successor (symbol :: GIOP/<ReplyStatusType>)
 => (succ :: GIOP/<ReplyStatusType>);

define generic GIOP/ReplyStatusType/predecessor (symbol :: GIOP/<ReplyStatusType>)
 => (pred :: GIOP/<ReplyStatusType>);

define generic GIOP/ReplyStatusType/< (lesser :: GIOP/<ReplyStatusType>, greater :: GIOP/<ReplyStatusType>)
 => (lesser? :: <boolean>);

define generic GIOP/ReplyStatusType/> (greater :: GIOP/<ReplyStatusType>, lesser :: GIOP/<ReplyStatusType>)
 => (greater? :: <boolean>);

define constant GIOP/$ReplyStatusType-typecode = make(<enum-typecode>, type: GIOP/<ReplyStatusType>, name: "ReplyStatusType", repository-id: "IDL:omg.org/GIOP/ReplyStatusType:1.0", members: vector(#"NO-EXCEPTION", #"USER-EXCEPTION", #"SYSTEM-EXCEPTION", #"LOCATION-FORWARD"));

define method class-typecode (class == GIOP/<ReplyStatusType>)
 => (typecode :: <enum-typecode>)
  GIOP/$ReplyStatusType-typecode;
end method;

define sideways method object-typecode (object :: GIOP/<ReplyStatusType>)
 => (typecode :: <enum-typecode>)
  GIOP/$ReplyStatusType-typecode;
end method;

define inline-only function GIOP/ReplyStatusType/as-symbol (integer :: <integer>)
 => (symbol :: GIOP/<ReplyStatusType>)
  let typecode = class-typecode(GIOP/<ReplyStatusType>);
  typecode-members(typecode)[integer];
end function;

define inline-only function GIOP/ReplyStatusType/as-integer (symbol :: GIOP/<ReplyStatusType>)
 => (integer :: <integer>)
  let typecode = class-typecode(GIOP/<ReplyStatusType>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method GIOP/ReplyStatusType/successor (symbol :: GIOP/<ReplyStatusType>)
 => (succ :: GIOP/<ReplyStatusType>)
  let i = GIOP/ReplyStatusType/as-integer(symbol);
  GIOP/ReplyStatusType/as-symbol(modulo(i + 1, 4));
end method;

define method GIOP/ReplyStatusType/predecessor (symbol :: GIOP/<ReplyStatusType>)
 => (pred :: GIOP/<ReplyStatusType>)
  let i = GIOP/ReplyStatusType/as-integer(symbol);
  GIOP/ReplyStatusType/as-symbol(modulo(4 + i - 1, 4));
end method;

define method GIOP/ReplyStatusType/< (lesser :: GIOP/<ReplyStatusType>, greater :: GIOP/<ReplyStatusType>)
 => (lesser? :: <boolean>)
  GIOP/ReplyStatusType/as-integer(lesser) < GIOP/ReplyStatusType/as-integer(greater);
end method;

define method GIOP/ReplyStatusType/> (greater :: GIOP/<ReplyStatusType>, lesser :: GIOP/<ReplyStatusType>)
 => (greater? :: <boolean>)
  GIOP/ReplyStatusType/as-integer(greater) > GIOP/ReplyStatusType/as-integer(lesser);
end method;

define sealed class GIOP/<ReplyHeader> (CORBA/<struct>)
  slot GIOP/ReplyHeader/service-context :: IOP/<ServiceContextList>, required-init-keyword: service-context:;
  slot GIOP/ReplyHeader/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
  slot GIOP/ReplyHeader/reply-status :: GIOP/<ReplyStatusType>, required-init-keyword: reply-status:;
end class;
define sealed domain make (singleton(GIOP/<ReplyHeader>));
define sealed domain initialize (GIOP/<ReplyHeader>);

define constant GIOP/$ReplyHeader-typecode = make(<struct-typecode>, type: GIOP/<ReplyHeader>, name: "ReplyHeader", repository-id: "IDL:omg.org/GIOP/ReplyHeader:1.0", members: vector(make(<typecode-member>, name: "service_context", type: IOP/<ServiceContextList>, getter: GIOP/ReplyHeader/service-context, setter: GIOP/ReplyHeader/service-context-setter, init-keyword: service-context:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), type: limited(CORBA/<sequence>, of: IOP/<ServiceContext>), max-length: 0, element-typecode: class-typecode(IOP/<ServiceContext>))), make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/ReplyHeader/request-id, setter: GIOP/ReplyHeader/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "reply_status", type: GIOP/<ReplyStatusType>, getter: GIOP/ReplyHeader/reply-status, setter: GIOP/ReplyHeader/reply-status-setter, init-keyword: reply-status:, typecode: class-typecode(GIOP/<ReplyStatusType>))));

define method class-typecode (class == GIOP/<ReplyHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$ReplyHeader-typecode;
end method;

define method object-typecode (object :: GIOP/<ReplyHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$ReplyHeader-typecode;
end method;

define sealed class GIOP/<CancelRequestHeader> (CORBA/<struct>)
  slot GIOP/CancelRequestHeader/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
end class;
define sealed domain make (singleton(GIOP/<CancelRequestHeader>));
define sealed domain initialize (GIOP/<CancelRequestHeader>);

define constant GIOP/$CancelRequestHeader-typecode = make(<struct-typecode>, type: GIOP/<CancelRequestHeader>, name: "CancelRequestHeader", repository-id: "IDL:omg.org/GIOP/CancelRequestHeader:1.0", members: vector(make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/CancelRequestHeader/request-id, setter: GIOP/CancelRequestHeader/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>))));

define method class-typecode (class == GIOP/<CancelRequestHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$CancelRequestHeader-typecode;
end method;

define method object-typecode (object :: GIOP/<CancelRequestHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$CancelRequestHeader-typecode;
end method;

define sealed class GIOP/<LocateRequestHeader> (CORBA/<struct>)
  slot GIOP/LocateRequestHeader/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
  slot GIOP/LocateRequestHeader/object-key :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: object-key:;
end class;
define sealed domain make (singleton(GIOP/<LocateRequestHeader>));
define sealed domain initialize (GIOP/<LocateRequestHeader>);

define constant GIOP/$LocateRequestHeader-typecode = make(<struct-typecode>, type: GIOP/<LocateRequestHeader>, name: "LocateRequestHeader", repository-id: "IDL:omg.org/GIOP/LocateRequestHeader:1.0", members: vector(make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/LocateRequestHeader/request-id, setter: GIOP/LocateRequestHeader/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "object_key", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: GIOP/LocateRequestHeader/object-key, setter: GIOP/LocateRequestHeader/object-key-setter, init-keyword: object-key:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>)))));

define method class-typecode (class == GIOP/<LocateRequestHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$LocateRequestHeader-typecode;
end method;

define method object-typecode (object :: GIOP/<LocateRequestHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$LocateRequestHeader-typecode;
end method;

define constant GIOP/<LocateStatusType> = one-of(#"UNKNOWN-OBJECT", #"OBJECT-HERE", #"OBJECT-FORWARD");

define generic GIOP/LocateStatusType/successor (symbol :: GIOP/<LocateStatusType>)
 => (succ :: GIOP/<LocateStatusType>);

define generic GIOP/LocateStatusType/predecessor (symbol :: GIOP/<LocateStatusType>)
 => (pred :: GIOP/<LocateStatusType>);

define generic GIOP/LocateStatusType/< (lesser :: GIOP/<LocateStatusType>, greater :: GIOP/<LocateStatusType>)
 => (lesser? :: <boolean>);

define generic GIOP/LocateStatusType/> (greater :: GIOP/<LocateStatusType>, lesser :: GIOP/<LocateStatusType>)
 => (greater? :: <boolean>);

define constant GIOP/$LocateStatusType-typecode = make(<enum-typecode>, type: GIOP/<LocateStatusType>, name: "LocateStatusType", repository-id: "IDL:omg.org/GIOP/LocateStatusType:1.0", members: vector(#"UNKNOWN-OBJECT", #"OBJECT-HERE", #"OBJECT-FORWARD"));

define method class-typecode (class == GIOP/<LocateStatusType>)
 => (typecode :: <enum-typecode>)
  GIOP/$LocateStatusType-typecode;
end method;

define sideways method object-typecode (object :: GIOP/<LocateStatusType>)
 => (typecode :: <enum-typecode>)
  GIOP/$LocateStatusType-typecode;
end method;

define inline-only function GIOP/LocateStatusType/as-symbol (integer :: <integer>)
 => (symbol :: GIOP/<LocateStatusType>)
  let typecode = class-typecode(GIOP/<LocateStatusType>);
  typecode-members(typecode)[integer];
end function;

define inline-only function GIOP/LocateStatusType/as-integer (symbol :: GIOP/<LocateStatusType>)
 => (integer :: <integer>)
  let typecode = class-typecode(GIOP/<LocateStatusType>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method GIOP/LocateStatusType/successor (symbol :: GIOP/<LocateStatusType>)
 => (succ :: GIOP/<LocateStatusType>)
  let i = GIOP/LocateStatusType/as-integer(symbol);
  GIOP/LocateStatusType/as-symbol(modulo(i + 1, 3));
end method;

define method GIOP/LocateStatusType/predecessor (symbol :: GIOP/<LocateStatusType>)
 => (pred :: GIOP/<LocateStatusType>)
  let i = GIOP/LocateStatusType/as-integer(symbol);
  GIOP/LocateStatusType/as-symbol(modulo(3 + i - 1, 3));
end method;

define method GIOP/LocateStatusType/< (lesser :: GIOP/<LocateStatusType>, greater :: GIOP/<LocateStatusType>)
 => (lesser? :: <boolean>)
  GIOP/LocateStatusType/as-integer(lesser) < GIOP/LocateStatusType/as-integer(greater);
end method;

define method GIOP/LocateStatusType/> (greater :: GIOP/<LocateStatusType>, lesser :: GIOP/<LocateStatusType>)
 => (greater? :: <boolean>)
  GIOP/LocateStatusType/as-integer(greater) > GIOP/LocateStatusType/as-integer(lesser);
end method;

define sealed class GIOP/<LocateReplyHeader> (CORBA/<struct>)
  slot GIOP/LocateReplyHeader/request-id :: CORBA/<unsigned-long>, required-init-keyword: request-id:;
  slot GIOP/LocateReplyHeader/locate-status :: GIOP/<LocateStatusType>, required-init-keyword: locate-status:;
end class;
define sealed domain make (singleton(GIOP/<LocateReplyHeader>));
define sealed domain initialize (GIOP/<LocateReplyHeader>);

define constant GIOP/$LocateReplyHeader-typecode = make(<struct-typecode>, type: GIOP/<LocateReplyHeader>, name: "LocateReplyHeader", repository-id: "IDL:omg.org/GIOP/LocateReplyHeader:1.0", members: vector(make(<typecode-member>, name: "request_id", type: CORBA/<unsigned-long>, getter: GIOP/LocateReplyHeader/request-id, setter: GIOP/LocateReplyHeader/request-id-setter, init-keyword: request-id:, typecode: make(<unsigned-long-typecode>)), make(<typecode-member>, name: "locate_status", type: GIOP/<LocateStatusType>, getter: GIOP/LocateReplyHeader/locate-status, setter: GIOP/LocateReplyHeader/locate-status-setter, init-keyword: locate-status:, typecode: class-typecode(GIOP/<LocateStatusType>))));

define method class-typecode (class == GIOP/<LocateReplyHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$LocateReplyHeader-typecode;
end method;

define method object-typecode (object :: GIOP/<LocateReplyHeader>)
 => (typecode :: <struct-typecode>)
  GIOP/$LocateReplyHeader-typecode;
end method;

define sealed class IIOP/<Version> (CORBA/<struct>)
  slot IIOP/Version/major :: CORBA/<octet>, required-init-keyword: major:;
  slot IIOP/Version/minor :: CORBA/<octet>, required-init-keyword: minor:;
end class;
define sealed domain make (singleton(IIOP/<Version>));
define sealed domain initialize (IIOP/<Version>);

define constant IIOP/$Version-typecode = make(<struct-typecode>, type: IIOP/<Version>, name: "Version", repository-id: "IDL:omg.org/IIOP/Version:1.0", members: vector(make(<typecode-member>, name: "major", type: CORBA/<octet>, getter: IIOP/Version/major, setter: IIOP/Version/major-setter, init-keyword: major:, typecode: make(<octet-typecode>)), make(<typecode-member>, name: "minor", type: CORBA/<octet>, getter: IIOP/Version/minor, setter: IIOP/Version/minor-setter, init-keyword: minor:, typecode: make(<octet-typecode>))));

define method class-typecode (class == IIOP/<Version>)
 => (typecode :: <struct-typecode>)
  IIOP/$Version-typecode;
end method;

define method object-typecode (object :: IIOP/<Version>)
 => (typecode :: <struct-typecode>)
  IIOP/$Version-typecode;
end method;

define sealed class IIOP/<ProfileBody-1-0> (CORBA/<struct>)
  slot IIOP/ProfileBody-1-0/iiop-version :: IIOP/<Version>, required-init-keyword: iiop-version:;
  slot IIOP/ProfileBody-1-0/host :: CORBA/<string>, required-init-keyword: host:;
  slot IIOP/ProfileBody-1-0/port :: CORBA/<unsigned-short>, required-init-keyword: port:;
  slot IIOP/ProfileBody-1-0/object-key :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: object-key:;
end class;
define sealed domain make (singleton(IIOP/<ProfileBody-1-0>));
define sealed domain initialize (IIOP/<ProfileBody-1-0>);

define constant IIOP/$ProfileBody-1-0-typecode = make(<struct-typecode>, type: IIOP/<ProfileBody-1-0>, name: "ProfileBody_1_0", repository-id: "IDL:omg.org/IIOP/ProfileBody_1_0:1.0", members: vector(make(<typecode-member>, name: "iiop_version", type: IIOP/<Version>, getter: IIOP/ProfileBody-1-0/iiop-version, setter: IIOP/ProfileBody-1-0/iiop-version-setter, init-keyword: iiop-version:, typecode: class-typecode(IIOP/<Version>)), make(<typecode-member>, name: "host", type: CORBA/<string>, getter: IIOP/ProfileBody-1-0/host, setter: IIOP/ProfileBody-1-0/host-setter, init-keyword: host:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "port", type: CORBA/<unsigned-short>, getter: IIOP/ProfileBody-1-0/port, setter: IIOP/ProfileBody-1-0/port-setter, init-keyword: port:, typecode: make(<unsigned-short-typecode>)), make(<typecode-member>, name: "object_key", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: IIOP/ProfileBody-1-0/object-key, setter: IIOP/ProfileBody-1-0/object-key-setter, init-keyword: object-key:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>)))));

define method class-typecode (class == IIOP/<ProfileBody-1-0>)
 => (typecode :: <struct-typecode>)
  IIOP/$ProfileBody-1-0-typecode;
end method;

define method object-typecode (object :: IIOP/<ProfileBody-1-0>)
 => (typecode :: <struct-typecode>)
  IIOP/$ProfileBody-1-0-typecode;
end method;

define sealed class IIOP/<ProfileBody-1-1> (CORBA/<struct>)
  slot IIOP/ProfileBody-1-1/iiop-version :: IIOP/<Version>, required-init-keyword: iiop-version:;
  slot IIOP/ProfileBody-1-1/host :: CORBA/<string>, required-init-keyword: host:;
  slot IIOP/ProfileBody-1-1/port :: CORBA/<unsigned-short>, required-init-keyword: port:;
  slot IIOP/ProfileBody-1-1/object-key :: limited(CORBA/<sequence>, of: CORBA/<octet>), required-init-keyword: object-key:;
  slot IIOP/ProfileBody-1-1/components :: limited(CORBA/<sequence>, of: IOP/<TaggedComponent>), required-init-keyword: components:;
end class;
define sealed domain make (singleton(IIOP/<ProfileBody-1-1>));
define sealed domain initialize (IIOP/<ProfileBody-1-1>);

define constant IIOP/$ProfileBody-1-1-typecode = make(<struct-typecode>, type: IIOP/<ProfileBody-1-1>, name: "ProfileBody_1_1", repository-id: "IDL:omg.org/IIOP/ProfileBody_1_1:1.0", members: vector(make(<typecode-member>, name: "iiop_version", type: IIOP/<Version>, getter: IIOP/ProfileBody-1-1/iiop-version, setter: IIOP/ProfileBody-1-1/iiop-version-setter, init-keyword: iiop-version:, typecode: class-typecode(IIOP/<Version>)), make(<typecode-member>, name: "host", type: CORBA/<string>, getter: IIOP/ProfileBody-1-1/host, setter: IIOP/ProfileBody-1-1/host-setter, init-keyword: host:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "port", type: CORBA/<unsigned-short>, getter: IIOP/ProfileBody-1-1/port, setter: IIOP/ProfileBody-1-1/port-setter, init-keyword: port:, typecode: make(<unsigned-short-typecode>)), make(<typecode-member>, name: "object_key", type: limited(CORBA/<sequence>, of: CORBA/<octet>), getter: IIOP/ProfileBody-1-1/object-key, setter: IIOP/ProfileBody-1-1/object-key-setter, init-keyword: object-key:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<octet>), type: limited(CORBA/<sequence>, of: CORBA/<octet>), max-length: 0, element-typecode: make(<octet-typecode>))), make(<typecode-member>, name: "components", type: limited(CORBA/<sequence>, of: IOP/<TaggedComponent>), getter: IIOP/ProfileBody-1-1/components, setter: IIOP/ProfileBody-1-1/components-setter, init-keyword: components:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: IOP/<TaggedComponent>), type: limited(CORBA/<sequence>, of: IOP/<TaggedComponent>), max-length: 0, element-typecode: class-typecode(IOP/<TaggedComponent>)))));

define method class-typecode (class == IIOP/<ProfileBody-1-1>)
 => (typecode :: <struct-typecode>)
  IIOP/$ProfileBody-1-1-typecode;
end method;

define method object-typecode (object :: IIOP/<ProfileBody-1-1>)
 => (typecode :: <struct-typecode>)
  IIOP/$ProfileBody-1-1-typecode;
end method;


/* eof */
