module: remote-nub-skeletons

define open abstract class Rtmgr/<AccessPath-servant> (Rtmgr/<AccessPath>, PortableServer/<servant>)
end class;

define method invoke-operation (object :: Rtmgr/<AccessPath-servant>, request :: CORBA/<ServerRequest>, operation == #"create_thread_stop_reason_handler")
 => ()
  let arguments = make(CORBA/<NVList>);
  let process = make(CORBA/<NamedValue>, name: "process", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  let priority = make(CORBA/<NamedValue>, name: "priority", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, priority);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/AccessPath/create-thread-stop-reason-handler(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
end method;

define method invoke-operation (object :: Rtmgr/<AccessPath-servant>, request :: CORBA/<ServerRequest>, operation == #"debugger_message")
 => ()
  let arguments = make(CORBA/<NVList>);
  let message = make(CORBA/<NamedValue>, name: "message", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, message);
  let arg1 = make(CORBA/<NamedValue>, name: "arg1", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg1);
  let arg2 = make(CORBA/<NamedValue>, name: "arg2", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg2);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/AccessPath/debugger-message(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
end method;

define method invoke-operation (object :: Rtmgr/<AccessPath-servant>, request :: CORBA/<ServerRequest>, operation == #"nub_debug_message")
 => ()
  let arguments = make(CORBA/<NVList>);
  let message = make(CORBA/<NamedValue>, name: "message", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, message);
  let arg1 = make(CORBA/<NamedValue>, name: "arg1", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg1);
  let arg2 = make(CORBA/<NamedValue>, name: "arg2", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg2);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/AccessPath/nub-debug-message(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
end method;

define method invoke-operation (object :: Rtmgr/<AccessPath-servant>, request :: CORBA/<ServerRequest>, operation == #"debugger_error")
 => ()
  let arguments = make(CORBA/<NVList>);
  let message = make(CORBA/<NamedValue>, name: "message", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, message);
  let arg1 = make(CORBA/<NamedValue>, name: "arg1", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg1);
  let arg2 = make(CORBA/<NamedValue>, name: "arg2", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg2);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/AccessPath/debugger-error(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
end method;

define open abstract class Rtmgr/<RemoteNub-servant> (Rtmgr/<RemoteNub>, PortableServer/<servant>)
end class;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"_get_process")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/process(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"_get_access_path")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/access-path(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: class-typecode(Rtmgr/<AccessPath>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"create_and_debug_process")
 => ()
  let arguments = make(CORBA/<NVList>);
  let command = make(CORBA/<NamedValue>, name: "command", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, command);
  let args = make(CORBA/<NamedValue>, name: "args", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, args);
  let path-count = make(CORBA/<NamedValue>, name: "path-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, path-count);
  let lib-count = make(CORBA/<NamedValue>, name: "lib-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, lib-count);
  let working-dir = make(CORBA/<NamedValue>, name: "working-dir", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, working-dir);
  let create-shell = make(CORBA/<NamedValue>, name: "create-shell", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, create-shell);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/create-and-debug-process(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])), CORBA/any/value(CORBA/NamedValue/argument(arguments[4])), CORBA/any/value(CORBA/NamedValue/argument(arguments[5])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"debug_active_process")
 => ()
  let arguments = make(CORBA/<NVList>);
  let process-name = make(CORBA/<NamedValue>, name: "process-name", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-name);
  let process-id = make(CORBA/<NamedValue>, name: "process-id", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-id);
  let actual-process-id = make(CORBA/<NamedValue>, name: "actual-process-id", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, actual-process-id);
  let path-count = make(CORBA/<NamedValue>, name: "path-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, path-count);
  let jit-info = make(CORBA/<NamedValue>, name: "jit-info", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, jit-info);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/debug-active-process(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])), CORBA/any/value(CORBA/NamedValue/argument(arguments[4])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"remote_value_byte_size")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/remote-value-byte-size(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_process_page_fault_count")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-process-page-fault-count(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_os_priority")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-os-priority(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_thread_cpu_time")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-thread-cpu-time(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_library_base_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let dll = make(CORBA/<NamedValue>, name: "dll", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, dll);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-library-base-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_library_version")
 => ()
  let arguments = make(CORBA/<NVList>);
  let dll = make(CORBA/<NamedValue>, name: "dll", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, dll);
  let maj = make(CORBA/<NamedValue>, name: "maj", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, maj);
  let min = make(CORBA/<NamedValue>, name: "min", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, min);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-library-version(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_library_filename")
 => ()
  let arguments = make(CORBA/<NVList>);
  let dll = make(CORBA/<NamedValue>, name: "dll", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, dll);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-library-filename(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_library_undecorated_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let dll = make(CORBA/<NamedValue>, name: "dll", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, dll);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-library-undecorated-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_register_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-register-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_register_enumeration_code")
 => ()
  let arguments = make(CORBA/<NVList>);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-register-enumeration-code(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"all_registers")
 => ()
  let arguments = make(CORBA/<NVList>);
  let first = make(CORBA/<NamedValue>, name: "first", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, first);
  let last = make(CORBA/<NamedValue>, name: "last", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, last);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/all-registers(object);
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"general_registers")
 => ()
  let arguments = make(CORBA/<NVList>);
  let first = make(CORBA/<NamedValue>, name: "first", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, first);
  let last = make(CORBA/<NamedValue>, name: "last", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, last);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/general-registers(object);
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"special_registers")
 => ()
  let arguments = make(CORBA/<NVList>);
  let first = make(CORBA/<NamedValue>, name: "first", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, first);
  let last = make(CORBA/<NamedValue>, name: "last", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, last);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/special-registers(object);
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"floating_registers")
 => ()
  let arguments = make(CORBA/<NVList>);
  let first = make(CORBA/<NamedValue>, name: "first", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, first);
  let last = make(CORBA/<NamedValue>, name: "last", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, last);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/floating-registers(object);
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"page_read_permission")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/page-read-permission(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"page_write_permission")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/page-write-permission(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"page_relative_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let offset = make(CORBA/<NamedValue>, name: "offset", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, offset);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/page-relative-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"virtual_page_size")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/virtual-page-size(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_value_from_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-value-from-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_value_to_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let val = make(CORBA/<NamedValue>, name: "val", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, val);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-value-to-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"calculate_stack_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let offset = make(CORBA/<NamedValue>, name: "offset", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, offset);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/calculate-stack-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"target_address_to_string")
 => ()
  let arguments = make(CORBA/<NVList>);
  let x = make(CORBA/<NamedValue>, name: "x", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, x);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  let radix = make(CORBA/<NamedValue>, name: "radix", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, radix);
  let pad = make(CORBA/<NamedValue>, name: "pad", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, pad);
  let truncated = make(CORBA/<NamedValue>, name: "truncated", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, truncated);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/target-address-to-string(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"string_to_target_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  let buffer = make(CORBA/<NamedValue>, name: "buffer", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, buffer);
  let radix = make(CORBA/<NamedValue>, name: "radix", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, radix);
  let overflow = make(CORBA/<NamedValue>, name: "overflow", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, overflow);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/string-to-target-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_single_float_from_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-single-float-from-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make( <float-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_single_float_to_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let value = make(CORBA/<NamedValue>, name: "value", argument: make(CORBA/<any>, type: make( <float-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, value);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-single-float-to-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_double_float_from_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-double-float-from-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<double-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_double_float_to_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let value = make(CORBA/<NamedValue>, name: "value", argument: make(CORBA/<any>, type: make(<double-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, value);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-double-float-to-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_byte_string_from_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  let buffer = make(CORBA/<NamedValue>, name: "buffer", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, buffer);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-byte-string-from-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_byte_string_to_process_memory")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  let buffer = make(CORBA/<NamedValue>, name: "buffer", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, buffer);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-byte-string-to-process-memory(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_value_from_process_register_in_stack_frame")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let frame-index = make(CORBA/<NamedValue>, name: "frame-index", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, frame-index);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-value-from-process-register-in-stack-frame(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_value_from_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-value-from-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_value_to_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let value = make(CORBA/<NamedValue>, name: "value", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, value);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-value-to-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_single_float_from_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-single-float-from-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make( <float-typecode>), value: results[0]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_single_float_to_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let value = make(CORBA/<NamedValue>, name: "value", argument: make(CORBA/<any>, type: make( <float-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, value);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-single-float-to-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_double_float_from_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-double-float-from-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<double-typecode>), value: results[0]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"write_double_float_to_process_register")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let reg = make(CORBA/<NamedValue>, name: "reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, reg);
  let value = make(CORBA/<NamedValue>, name: "value", argument: make(CORBA/<any>, type: make(<double-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, value);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/write-double-float-to-process-register(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_restart")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-restart(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_stop")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-stop(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_continue")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-continue(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_continue_unhandled")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-continue-unhandled(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_step")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-step(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_step_over")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-step-over(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"application_step_out")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/application-step-out(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"set_stepping_control_on_thread")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let fp = make(CORBA/<NamedValue>, name: "fp", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, fp);
  let calling-fp = make(CORBA/<NamedValue>, name: "calling-fp", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, calling-fp);
  let location-count = make(CORBA/<NamedValue>, name: "location-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, location-count);
  let locs = make(CORBA/<NamedValue>, name: "locs", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, locs);
  let operation = make(CORBA/<NamedValue>, name: "operation", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, operation);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/set-stepping-control-on-thread(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])), CORBA/any/value(CORBA/NamedValue/argument(arguments[4])), CORBA/any/value(CORBA/NamedValue/argument(arguments[5])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"clear_stepping_control_on_thread")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/clear-stepping-control-on-thread(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_stop")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-stop(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_continue")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-continue(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_suspendedQ")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-suspendedQ(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_suspended")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-suspended(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_resumed")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-resumed(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"kill_application")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/kill-application(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"close_application")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/close-application(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"close_remote_tether")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/close-remote-tether(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"setup_function_call")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let func = make(CORBA/<NamedValue>, name: "func", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, func);
  let arg-count = make(CORBA/<NamedValue>, name: "arg-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg-count);
  let args = make(CORBA/<NamedValue>, name: "args", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, args);
  let cx-handle = make(CORBA/<NamedValue>, name: "cx-handle", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, cx-handle);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/setup-function-call(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"remote_call_spy")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let func = make(CORBA/<NamedValue>, name: "func", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, func);
  let arg-count = make(CORBA/<NamedValue>, name: "arg-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, arg-count);
  let args = make(CORBA/<NamedValue>, name: "args", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, args);
  let status = make(CORBA/<NamedValue>, name: "status", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, status);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/remote-call-spy(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_function_result")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-function-result(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"restore_context")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let the-context = make(CORBA/<NamedValue>, name: "the-context", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, the-context);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/restore-context(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"set_breakpoint")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/set-breakpoint(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"clear_breakpoint")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/clear-breakpoint(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"query_breakpoint")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/query-breakpoint(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"wait_for_stop_reason_with_timeout")
 => ()
  let arguments = make(CORBA/<NVList>);
  let timeout = make(CORBA/<NamedValue>, name: "timeout", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, timeout);
  let code = make(CORBA/<NamedValue>, name: "code", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, code);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/wait-for-stop-reason-with-timeout(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"profile_wait_for_stop_reason_with_timeout")
 => ()
  let arguments = make(CORBA/<NVList>);
  let timeout = make(CORBA/<NamedValue>, name: "timeout", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, timeout);
  let profiling-interval = make(CORBA/<NamedValue>, name: "profiling-interval", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, profiling-interval);
  let code = make(CORBA/<NamedValue>, name: "code", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, code);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/profile-wait-for-stop-reason-with-timeout(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"inform_profiling_started")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/inform-profiling-started(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"inform_profiling_stopped")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/inform-profiling-stopped(object);
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"can_receive_first_chance")
 => ()
  let arguments = make(CORBA/<NVList>);
  let ecode = make(CORBA/<NamedValue>, name: "ecode", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, ecode);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/can-receive-first-chance(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"set_first_chance")
 => ()
  let arguments = make(CORBA/<NVList>);
  let ecode = make(CORBA/<NamedValue>, name: "ecode", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, ecode);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/set-first-chance(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"unset_first_chance")
 => ()
  let arguments = make(CORBA/<NVList>);
  let ecode = make(CORBA/<NamedValue>, name: "ecode", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, ecode);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/unset-first-chance(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"thread_stop_information")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let fchance = make(CORBA/<NamedValue>, name: "fchance", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, fchance);
  let fstart = make(CORBA/<NamedValue>, name: "fstart", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, fstart);
  let ret-addr = make(CORBA/<NamedValue>, name: "ret-addr", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, ret-addr);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/thread-stop-information(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[3]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"wait_for_stop_reason_no_timeout")
 => ()
  let arguments = make(CORBA/<NVList>);
  let ecode = make(CORBA/<NamedValue>, name: "ecode", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, ecode);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/wait-for-stop-reason-no-timeout(object);
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"profile_wait_for_stop_reason_no_timeout")
 => ()
  let arguments = make(CORBA/<NVList>);
  let profile-interval = make(CORBA/<NamedValue>, name: "profile-interval", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, profile-interval);
  let ecode = make(CORBA/<NamedValue>, name: "ecode", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, ecode);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/profile-wait-for-stop-reason-no-timeout(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_process")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-process(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_thread")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-thread(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"first_hard_coded_breakpoint")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/first-hard-coded-breakpoint(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_process_exit_code")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-process-exit-code(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_thread_exit_code")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-thread-exit-code(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_library")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-library(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_violation_op")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-violation-op(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"exception_first_chance")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/exception-first-chance(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_violation_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-violation-address(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_exception_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-exception-address(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_debug_string_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-debug-string-address(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_debug_string_length")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-debug-string-length(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"stop_reason_debug_string_is_unicode")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/stop-reason-debug-string-is-unicode(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"initialize_stack_vectors")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/initialize-stack-vectors(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"read_stack_vectors")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let frame-count = make(CORBA/<NamedValue>, name: "frame-count", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, frame-count);
  let frame-pointers = make(CORBA/<NamedValue>, name: "frame-pointers", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, frame-pointers);
  let instruction-pointers = make(CORBA/<NamedValue>, name: "instruction-pointers", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, instruction-pointers);
  let return-addresses = make(CORBA/<NamedValue>, name: "return-addresses", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>))), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, return-addresses);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/read-stack-vectors(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>)), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>)), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), type: limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>), max-length: 0, element-typecode: make(<unsigned-long-typecode>)), value: results[2]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"all_frame_lexicals")
 => ()
  let arguments = make(CORBA/<NVList>);
  let frame = make(CORBA/<NamedValue>, name: "frame", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, frame);
  let ip = make(CORBA/<NamedValue>, name: "ip", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, ip);
  let first = make(CORBA/<NamedValue>, name: "first", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, first);
  let last = make(CORBA/<NamedValue>, name: "last", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, last);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, table);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/all-frame-lexicals(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"register_interactive_code_segment")
 => ()
  let arguments = make(CORBA/<NVList>);
  let lo = make(CORBA/<NamedValue>, name: "lo", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, lo);
  let hi = make(CORBA/<NamedValue>, name: "hi", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, hi);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/register-interactive-code-segment(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_lexical_variable_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let variable = make(CORBA/<NamedValue>, name: "variable", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, variable);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-lexical-variable-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lexical_variable_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let fp = make(CORBA/<NamedValue>, name: "fp", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, fp);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let variable = make(CORBA/<NamedValue>, name: "variable", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, variable);
  let in-reg = make(CORBA/<NamedValue>, name: "in-reg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, in-reg);
  let hireg = make(CORBA/<NamedValue>, name: "hireg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, hireg);
  let loreg = make(CORBA/<NamedValue>, name: "loreg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, loreg);
  let arg = make(CORBA/<NamedValue>, name: "arg", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, arg);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lexical-variable-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
  arguments[5] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[5]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[3]), len: CORBA/NamedValue/len(arguments[5]), arg-modes: CORBA/NamedValue/arg-modes(arguments[5]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[4]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_symbol_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-symbol-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_symbol_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-symbol-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_function_debug_start")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-function-debug-start(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_function_debug_end")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-function-debug-end(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_symbol_language")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-symbol-language(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"lookup_function_end")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/lookup-function-end(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"symbol_is_function")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let sym = make(CORBA/<NamedValue>, name: "sym", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sym);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/symbol-is-function(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"nearest_symbols")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let lib = make(CORBA/<NamedValue>, name: "lib", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, lib);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, table);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/nearest-symbols(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"closest_symbol")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let lib = make(CORBA/<NamedValue>, name: "lib", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, lib);
  let actual-address = make(CORBA/<NamedValue>, name: "actual-address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, actual-address);
  let offset = make(CORBA/<NamedValue>, name: "offset", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, offset);
  let name-length = make(CORBA/<NamedValue>, name: "name-length", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, name-length);
  let type = make(CORBA/<NamedValue>, name: "type", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, type);
  let is-function = make(CORBA/<NamedValue>, name: "is-function", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, is-function);
  let debug-start = make(CORBA/<NamedValue>, name: "debug-start", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, debug-start);
  let debug-end = make(CORBA/<NamedValue>, name: "debug-end", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, debug-end);
  let language = make(CORBA/<NamedValue>, name: "language", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, language);
  let final-address-of-definition = make(CORBA/<NamedValue>, name: "final-address-of-definition", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, final-address-of-definition);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/closest-symbol(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[3]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[4]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
  arguments[5] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[5]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[5]), len: CORBA/NamedValue/len(arguments[5]), arg-modes: CORBA/NamedValue/arg-modes(arguments[5]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[6]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
  arguments[7] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[7]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[7]), len: CORBA/NamedValue/len(arguments[7]), arg-modes: CORBA/NamedValue/arg-modes(arguments[7]));
  arguments[8] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[8]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[8]), len: CORBA/NamedValue/len(arguments[8]), arg-modes: CORBA/NamedValue/arg-modes(arguments[8]));
  arguments[9] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[9]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[9]), len: CORBA/NamedValue/len(arguments[9]), arg-modes: CORBA/NamedValue/arg-modes(arguments[9]));
  arguments[10] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[10]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[10]), len: CORBA/NamedValue/len(arguments[10]), arg-modes: CORBA/NamedValue/arg-modes(arguments[10]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"function_bounding_addresses")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let lower = make(CORBA/<NamedValue>, name: "lower", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, lower);
  let upper = make(CORBA/<NamedValue>, name: "upper", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, upper);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/function-bounding-addresses(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"closest_symbol_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/closest-symbol-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"find_symbol_in_library")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nublibrary = make(CORBA/<NamedValue>, name: "nublibrary", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nublibrary);
  let sz = make(CORBA/<NamedValue>, name: "sz", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, sz);
  let name = make(CORBA/<NamedValue>, name: "name", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, name);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, address);
  let type = make(CORBA/<NamedValue>, name: "type", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, type);
  let is-function = make(CORBA/<NamedValue>, name: "is-function", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, is-function);
  let debug-start = make(CORBA/<NamedValue>, name: "debug-start", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, debug-start);
  let debug-end = make(CORBA/<NamedValue>, name: "debug-end", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, debug-end);
  let symbol-language = make(CORBA/<NamedValue>, name: "symbol-language", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, symbol-language);
  let final-address-of-definition = make(CORBA/<NamedValue>, name: "final-address-of-definition", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, final-address-of-definition);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/find-symbol-in-library(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
  arguments[5] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[5]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[3]), len: CORBA/NamedValue/len(arguments[5]), arg-modes: CORBA/NamedValue/arg-modes(arguments[5]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[4]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
  arguments[7] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[7]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[5]), len: CORBA/NamedValue/len(arguments[7]), arg-modes: CORBA/NamedValue/arg-modes(arguments[7]));
  arguments[8] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[8]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[6]), len: CORBA/NamedValue/len(arguments[8]), arg-modes: CORBA/NamedValue/arg-modes(arguments[8]));
  arguments[9] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[9]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[7]), len: CORBA/NamedValue/len(arguments[9]), arg-modes: CORBA/NamedValue/arg-modes(arguments[9]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dispose_lookups")
 => ()
  let arguments = make(CORBA/<NVList>);
  let lookups = make(CORBA/<NamedValue>, name: "lookups", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, lookups);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dispose-lookups(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"resolve_source_location")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nublibrary = make(CORBA/<NamedValue>, name: "nublibrary", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nublibrary);
  let filename = make(CORBA/<NamedValue>, name: "filename", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, filename);
  let line-number = make(CORBA/<NamedValue>, name: "line-number", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, line-number);
  let column-number = make(CORBA/<NamedValue>, name: "column-number", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, column-number);
  let valid = make(CORBA/<NamedValue>, name: "valid", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, valid);
  let path = make(CORBA/<NamedValue>, name: "path", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, path);
  let search = make(CORBA/<NamedValue>, name: "search", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, search);
  let exact = make(CORBA/<NamedValue>, name: "exact", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, exact);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/resolve-source-location(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[4] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[4]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[4]), arg-modes: CORBA/NamedValue/arg-modes(arguments[4]));
  arguments[5] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[5]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[5]), arg-modes: CORBA/NamedValue/arg-modes(arguments[5]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[3]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
  arguments[7] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[7]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[4]), len: CORBA/NamedValue/len(arguments[7]), arg-modes: CORBA/NamedValue/arg-modes(arguments[7]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"fetch_source_locations")
 => ()
  let arguments = make(CORBA/<NVList>);
  let start-loc = make(CORBA/<NamedValue>, name: "start-loc", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, start-loc);
  let end-loc = make(CORBA/<NamedValue>, name: "end-loc", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, end-loc);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/fetch-source-locations(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"source_location_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let index = make(CORBA/<NamedValue>, name: "index", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, index);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/source-location-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"source_location_linenumber")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  let index = make(CORBA/<NamedValue>, name: "index", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, index);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/source-location-linenumber(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"source_location_filename")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/source-location-filename(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"number_of_source_locations")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/number-of-source-locations(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dispose_source_locations")
 => ()
  let arguments = make(CORBA/<NVList>);
  let table = make(CORBA/<NamedValue>, name: "table", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, table);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dispose-source-locations(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"interpret_instruction_at_current_location")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let flow = make(CORBA/<NamedValue>, name: "flow", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, flow);
  let destination = make(CORBA/<NamedValue>, name: "destination", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, destination);
  let instruction-size = make(CORBA/<NamedValue>, name: "instruction-size", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, instruction-size);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/interpret-instruction-at-current-location(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
  arguments[3] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[3]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[3]), arg-modes: CORBA/NamedValue/arg-modes(arguments[3]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dylan_calculate_step_into")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  let function-register-live = make(CORBA/<NamedValue>, name: "function-register-live", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, function-register-live);
  let ok = make(CORBA/<NamedValue>, name: "ok", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, ok);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dylan-calculate-step-into(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[2]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dylan_thread_environment_block_address")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  let valid = make(CORBA/<NamedValue>, name: "valid", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, valid);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dylan-thread-environment-block-address(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dylan_thread_mv_buffer_live")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dylan-thread-mv-buffer-live(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"older_stack_frame")
 => ()
  let arguments = make(CORBA/<NVList>);
  let this-one = make(CORBA/<NamedValue>, name: "this-one", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, this-one);
  let than-this-one = make(CORBA/<NamedValue>, name: "than-this-one", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, than-this-one);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/older-stack-frame(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"dylan_current_function")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubthread = make(CORBA/<NamedValue>, name: "nubthread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubthread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/dylan-current-function(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"perform_absolute_relocation")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let destination = make(CORBA/<NamedValue>, name: "destination", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, destination);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/perform-absolute-relocation(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"perform_relative_relocation")
 => ()
  let arguments = make(CORBA/<NVList>);
  let address = make(CORBA/<NamedValue>, name: "address", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, address);
  let destination = make(CORBA/<NamedValue>, name: "destination", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, destination);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/perform-relative-relocation(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"recover_breakpoint")
 => ()
  let arguments = make(CORBA/<NVList>);
  let thread = make(CORBA/<NamedValue>, name: "thread", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, thread);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/recover-breakpoint(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"get_process_wall_clock_time")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/get-process-wall-clock-time(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"register_exit_process_function")
 => ()
  let arguments = make(CORBA/<NVList>);
  let ExitProcess = make(CORBA/<NamedValue>, name: "ExitProcess", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, ExitProcess);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/register-exit-process-function(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"open_local_tether")
 => ()
  let arguments = make(CORBA/<NVList>);
  let command = make(CORBA/<NamedValue>, name: "command", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, command);
  let args = make(CORBA/<NamedValue>, name: "args", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, args);
  let paths = make(CORBA/<NamedValue>, name: "paths", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<string>), type: limited(CORBA/<sequence>, of: CORBA/<string>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, paths);
  let lib-paths = make(CORBA/<NamedValue>, name: "lib-paths", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<string>), type: limited(CORBA/<sequence>, of: CORBA/<string>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, lib-paths);
  let working-directory = make(CORBA/<NamedValue>, name: "working-directory", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, working-directory);
  let create-shell = make(CORBA/<NamedValue>, name: "create-shell", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, create-shell);
  let success = make(CORBA/<NamedValue>, name: "success", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, success);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/open-local-tether(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])), CORBA/any/value(CORBA/NamedValue/argument(arguments[4])), CORBA/any/value(CORBA/NamedValue/argument(arguments[5])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"attach_local_tether")
 => ()
  let arguments = make(CORBA/<NVList>);
  let process = make(CORBA/<NamedValue>, name: "process", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process);
  let process-name = make(CORBA/<NamedValue>, name: "process-name", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-name);
  let process-system-id = make(CORBA/<NamedValue>, name: "process-system-id", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-system-id);
  let process-actual-id = make(CORBA/<NamedValue>, name: "process-actual-id", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-actual-id);
  let symbol-paths = make(CORBA/<NamedValue>, name: "symbol-paths", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<string>), type: limited(CORBA/<sequence>, of: CORBA/<string>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, symbol-paths);
  let system-JIT-information = make(CORBA/<NamedValue>, name: "system-JIT-information", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, system-JIT-information);
  let success = make(CORBA/<NamedValue>, name: "success", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, success);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/attach-local-tether(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])), CORBA/any/value(CORBA/NamedValue/argument(arguments[4])), CORBA/any/value(CORBA/NamedValue/argument(arguments[5])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
  arguments[6] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[6]), argument: make(CORBA/<any>, type: make(<long-typecode>), value: results[1]), len: CORBA/NamedValue/len(arguments[6]), arg-modes: CORBA/NamedValue/arg-modes(arguments[6]));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"OpenNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  let access-path = make(CORBA/<NamedValue>, name: "access-path", argument: make(CORBA/<any>, type: class-typecode(Rtmgr/<AccessPath>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, access-path);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/OpenNub(object, as(Rtmgr/<AccessPath>, CORBA/any/value(CORBA/NamedValue/argument(arguments[0]))));
end method;

define method invoke-operation (object :: Rtmgr/<RemoteNub-servant>, request :: CORBA/<ServerRequest>, operation == #"CloseNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/RemoteNub/CloseNub(object);
end method;

define open abstract class Rtmgr/<NubServer-servant> (Rtmgr/<NubServer>, PortableServer/<servant>)
end class;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"_get_nubs")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/nubs(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: Rtmgr/<RemoteNub>), type: limited(CORBA/<sequence>, of: Rtmgr/<RemoteNub>), max-length: 0, element-typecode: class-typecode(Rtmgr/<RemoteNub>)), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"CreateNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  let process-name = make(CORBA/<NamedValue>, name: "process-name", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-name);
  let remote-machine = make(CORBA/<NamedValue>, name: "remote-machine", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, remote-machine);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/CreateNub(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: class-typecode(Rtmgr/<RemoteNub>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"DestroyNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nub = make(CORBA/<NamedValue>, name: "nub", argument: make(CORBA/<any>, type: class-typecode(Rtmgr/<RemoteNub>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nub);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/DestroyNub(object, as(Rtmgr/<RemoteNub>, CORBA/any/value(CORBA/NamedValue/argument(arguments[0]))));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"RegisterNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nub = make(CORBA/<NamedValue>, name: "nub", argument: make(CORBA/<any>, type: class-typecode(Rtmgr/<RemoteNub>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nub);
  let process-name = make(CORBA/<NamedValue>, name: "process-name", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-name);
  let process-id = make(CORBA/<NamedValue>, name: "process-id", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, process-id);
  let remote-machine = make(CORBA/<NamedValue>, name: "remote-machine", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, remote-machine);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/RegisterNub(object, as(Rtmgr/<RemoteNub>, CORBA/any/value(CORBA/NamedValue/argument(arguments[0]))), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])), CORBA/any/value(CORBA/NamedValue/argument(arguments[2])), CORBA/any/value(CORBA/NamedValue/argument(arguments[3])));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"DeregisterNub")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nub = make(CORBA/<NamedValue>, name: "nub", argument: make(CORBA/<any>, type: class-typecode(Rtmgr/<RemoteNub>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nub);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/DeregisterNub(object, as(Rtmgr/<RemoteNub>, CORBA/any/value(CORBA/NamedValue/argument(arguments[0]))));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"ShutdownServer")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/ShutdownServer(object);
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"get_local_hostname")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/get-local-hostname(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"verify_local_password")
 => ()
  let arguments = make(CORBA/<NVList>);
  let password = make(CORBA/<NamedValue>, name: "password", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, password);
  let remote-machine = make(CORBA/<NamedValue>, name: "remote-machine", argument: make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, remote-machine);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/verify-local-password(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"update_local_process_list")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/update-local-process-list(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"local_process_nub_descriptor")
 => ()
  let arguments = make(CORBA/<NVList>);
  let i = make(CORBA/<NamedValue>, name: "i", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, i);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/local-process-nub-descriptor(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"local_process_identifier")
 => ()
  let arguments = make(CORBA/<NVList>);
  let nubprocess = make(CORBA/<NamedValue>, name: "nubprocess", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nubprocess);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/local-process-identifier(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<long-typecode>), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"local_process_name")
 => ()
  let arguments = make(CORBA/<NVList>);
  let i = make(CORBA/<NamedValue>, name: "i", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, i);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/local-process-name(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"local_process_system_identifier")
 => ()
  let arguments = make(CORBA/<NVList>);
  let i = make(CORBA/<NamedValue>, name: "i", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, i);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/local-process-system-identifier(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<string-typecode>, type: CORBA/<string>, max-length: 0), value: results[0]));
end method;

define method invoke-operation (object :: Rtmgr/<NubServer-servant>, request :: CORBA/<ServerRequest>, operation == #"local_process_actual_identifier")
 => ()
  let arguments = make(CORBA/<NVList>);
  let i = make(CORBA/<NamedValue>, name: "i", argument: make(CORBA/<any>, type: make(<long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, i);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = Rtmgr/NubServer/local-process-actual-identifier(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<unsigned-long-typecode>), value: results[0]));
end method;


/* eof */
